var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useEffect, useState } from 'react';
import { useWidgetContext } from '../context';
var KNOWLEDGE_POOL_VALIDATION_NAME = 'validation';
export var useKiCounts = function () {
    var _a = useState({
        counts: { total: 0, live: 0, validation: 0, undeployed: 0 },
        loading: true,
        error: false,
    }), data = _a[0], setData = _a[1];
    var _b = useWidgetContext(), client = _b.client, selectScopeId = _b.provider.selectScopeId;
    var scopeId = selectScopeId();
    useEffect(function () {
        var fetchKICounts = function () { return __awaiter(void 0, void 0, void 0, function () {
            var allKnowledgePools, total, validation, allLiveKiIds, _i, allKnowledgePools_1, knowledgePool, validationKiCount, liveKiIds, liveDedupedCount;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, client.lucene("+(ogit\\/_type:\"ogit/Automation/KnowledgePool\") +(ogit\\/_scope: \"" + scopeId + "\")", {
                            limit: -1,
                        })];
                    case 1:
                        allKnowledgePools = _b.sent();
                        return [4 /*yield*/, client.lucene("+(ogit\\/_type:\"ogit/Automation/KnowledgeItem\") +(ogit\\/_scope: \"" + scopeId + "\")", {
                                limit: -1,
                                count: true,
                            })];
                    case 2:
                        total = (_b.sent())[0];
                        validation = 0;
                        allLiveKiIds = [];
                        _i = 0, allKnowledgePools_1 = allKnowledgePools;
                        _b.label = 3;
                    case 3:
                        if (!(_i < allKnowledgePools_1.length)) return [3 /*break*/, 8];
                        knowledgePool = allKnowledgePools_1[_i];
                        if (!(((_a = knowledgePool['ogit/name']) === null || _a === void 0 ? void 0 : _a.toLowerCase()) ===
                            KNOWLEDGE_POOL_VALIDATION_NAME)) return [3 /*break*/, 5];
                        return [4 /*yield*/, client.gremlin(knowledgePool['ogit/_id'], "outE(\"ogit/uses\").inV().has(\"ogit/_scope\", \"" + scopeId + "\").count()")];
                    case 4:
                        validationKiCount = (_b.sent())[0];
                        validation = validationKiCount;
                        return [3 /*break*/, 7];
                    case 5: return [4 /*yield*/, client.gremlin(knowledgePool['ogit/_id'], "outE(\"ogit/uses\").inV().has(\"ogit/_scope\", \"" + scopeId + "\").values(\"ogit/_id\")")];
                    case 6:
                        liveKiIds = _b.sent();
                        allLiveKiIds.push.apply(allLiveKiIds, liveKiIds);
                        _b.label = 7;
                    case 7:
                        _i++;
                        return [3 /*break*/, 3];
                    case 8:
                        liveDedupedCount = new Set(allLiveKiIds).size;
                        setData({
                            counts: {
                                total: total,
                                validation: validation,
                                live: liveDedupedCount,
                                undeployed: total - liveDedupedCount - validation,
                            },
                            loading: false,
                            error: false,
                        });
                        return [2 /*return*/];
                }
            });
        }); };
        try {
            setData(function (state) { return (__assign(__assign({}, state), { loading: true })); });
            fetchKICounts();
        }
        catch (e) {
            setData(function (state) { return (__assign(__assign({}, state), { error: true })); });
        }
    }, [client, scopeId]);
    return data;
};
